/*
 * ====================== WARNING ======================
 *
 * THE CONTENTS OF THIS FILE HAVE BEEN AUTO-GENERATED.
 * DO NOT MODIFY IN ANY WAY.
 *
 * ====================== WARNING ======================
 */


#ifndef LE_ENOCEAN_INTERFACE_H_INCLUDE_GUARD
#define LE_ENOCEAN_INTERFACE_H_INCLUDE_GUARD


#include "legato.h"

//--------------------------------------------------------------------------------------------------
/**
 *
 * Connect the current client thread to the service providing this API. Block until the service is
 * available.
 *
 * For each thread that wants to use this API, either ConnectService or TryConnectService must be
 * called before any other functions in this API.  Normally, ConnectService is automatically called
 * for the main thread, but not for any other thread. For details, see @ref apiFilesC_client.
 *
 * This function is created automatically.
 */
//--------------------------------------------------------------------------------------------------
void le_EnOcean_ConnectService
(
    void
);

//--------------------------------------------------------------------------------------------------
/**
 *
 * Try to connect the current client thread to the service providing this API. Return with an error
 * if the service is not available.
 *
 * For each thread that wants to use this API, either ConnectService or TryConnectService must be
 * called before any other functions in this API.  Normally, ConnectService is automatically called
 * for the main thread, but not for any other thread. For details, see @ref apiFilesC_client.
 *
 * This function is created automatically.
 *
 * @return
 *  - LE_OK if the client connected successfully to the service.
 *  - LE_UNAVAILABLE if the server is not currently offering the service to which the client is bound.
 *  - LE_NOT_PERMITTED if the client interface is not bound to any service (doesn't have a binding).
 *  - LE_COMM_ERROR if the Service Directory cannot be reached.
 */
//--------------------------------------------------------------------------------------------------
le_result_t le_EnOcean_TryConnectService
(
    void
);

//--------------------------------------------------------------------------------------------------
/**
 *
 * Disconnect the current client thread from the service providing this API.
 *
 * Normally, this function doesn't need to be called. After this function is called, there's no
 * longer a connection to the service, and the functions in this API can't be used. For details, see
 * @ref apiFilesC_client.
 *
 * This function is created automatically.
 */
//--------------------------------------------------------------------------------------------------
void le_EnOcean_DisconnectService
(
    void
);


//--------------------------------------------------------------------------------------------------
/**
 * Reference type used by Add/Remove functions for EVENT 'le_EnOcean_OnReceive'
 */
//--------------------------------------------------------------------------------------------------
typedef struct le_EnOcean_OnReceiveHandler* le_EnOcean_OnReceiveHandlerRef_t;


//--------------------------------------------------------------------------------------------------
/**
 * Add handler function for EVENT 'le_EnOcean_AddOnReceiveHandler'
 *
 * This event provides response from module.
 *
 * @param PacketType
 *        Packet Type
 * @param Data
 *        Data to send
 * @param DataNumElements
 * @param contextPtr
 */
//--------------------------------------------------------------------------------------------------
typedef void (*le_EnOcean_HandlerRefFunc_t)
(
    uint8_t PacketType,
    const uint8_t* DataPtr,
    size_t DataNumElements,
    void* contextPtr
);

//--------------------------------------------------------------------------------------------------
/**
 ** Send Bytes.
 *
 * Returns:
 * LE_OK if Successful.
 * LE_BAD_PARAMETER if bad parameter
 */
//--------------------------------------------------------------------------------------------------
le_result_t le_EnOcean_SendData
(
    uint8_t PacketType,
        ///< [IN] Packet Type

    const uint8_t* DataPtr,
        ///< [IN] Data to send

    size_t DataNumElements,
        ///< [IN]

    const uint8_t* OptionalDataPtr,
        ///< [IN] Optional Data to send

    size_t OptionalDataNumElements
        ///< [IN]

);

//--------------------------------------------------------------------------------------------------
/**
 * Add handler function for EVENT 'le_EnOcean_OnReceive'
 */
//--------------------------------------------------------------------------------------------------
le_EnOcean_OnReceiveHandlerRef_t le_EnOcean_AddOnReceiveHandler
(
    le_EnOcean_HandlerRefFunc_t handlerPtr,
        ///< [IN]

    void* contextPtr
        ///< [IN]

);

//--------------------------------------------------------------------------------------------------
/**
 * Remove handler function for EVENT 'le_EnOcean_OnReceive'
 */
//--------------------------------------------------------------------------------------------------
void le_EnOcean_RemoveOnReceiveHandler
(
    le_EnOcean_OnReceiveHandlerRef_t addHandlerRef
        ///< [IN]

);


#endif // LE_ENOCEAN_INTERFACE_H_INCLUDE_GUARD

